package com.fp.persistence.pgeneral.product.rate;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import java.math.BigDecimal;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import javax.persistence.Version;
import java.lang.reflect.Field;
import javax.persistence.Transient;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TGENERATESGROUP*/
@Entity(name="TgeneRatesGroup")
@Table(name="TGENERATESGROUP")
public class TgeneRatesGroup extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TgeneRatesGroup
*/
@EmbeddedId
private TgeneRatesGroupKey pk;
@Column(name="BASERATECATALOG", nullable=false)

/**
* Codigo de catalogo  01 Natural, 02 Juridico
*/
private String baseratecatalog;

@Column(name="BASERATECATALOGCODE", nullable=false)

/**
* Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
private String baseratecatalogcode;

@Version
@Column(name="RECORDVERSION", nullable=true)

/**
* Manejo de optimistic locking
*/
private Integer recordversion;

@Column(name="MAXTERM", nullable=true)

/**
* Plazo  maximo
*/
private Integer maxterm;

@Column(name="MAXAMOUNT", nullable=true)

/**
* Monto Maximo
*/
private BigDecimal maxamount;

@Column(name="MARGIN", nullable=true)

/**
* Margen a aplicar dado el operador
*/
private BigDecimal margin;

@Column(name="OPERATOR", nullable=true)

/**
* Operador a aplicar sobre la tasa base, +, - , % 
*/
private String operator;

/**Contructor por defecto*/
public TgeneRatesGroup(){
}
/**Contructor de TgeneRatesGroup
@param pPk Clave Primaria del entity
@param pBaseratecatalog Codigo de catalogo  01 Natural, 02 Juridico
@param pBaseratecatalogcode Codigo de tabla de catalogo 01 Codigo de tabla de tipos de persona
*/
public TgeneRatesGroup(TgeneRatesGroupKey pPk,String pBaseratecatalog,String pBaseratecatalogcode){
 this();
 pk=pPk;
 baseratecatalog=pBaseratecatalog;
 baseratecatalogcode=pBaseratecatalogcode;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TgeneRatesGroup
*/
public static TgeneRatesGroup find(EntityManager pEntityManager,TgeneRatesGroupKey pKey) throws Exception{
    TgeneRatesGroup obj = pEntityManager.find(TgeneRatesGroup.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TgeneRatesGroup
@return El objeto que referencia a la Clave primaria de TgeneRatesGroup
*/
public TgeneRatesGroupKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TgeneRatesGroup
@param pPk El objeto que referencia a la nueva Clave primaria de TgeneRatesGroup
*/
public void setPk(TgeneRatesGroupKey pPk){
  pk=pPk;
}
/**Obtiene el valor de baseratecatalog
@return valor de baseratecatalog*/
public String getBaseratecatalog(){
  return baseratecatalog;
}
/**Fija el valor de baseratecatalog
@param pBaseratecatalog nuevo Valor de baseratecatalog*/
public void setBaseratecatalog(String pBaseratecatalog){
  baseratecatalog=pBaseratecatalog;
}

/**Obtiene el valor de baseratecatalogcode
@return valor de baseratecatalogcode*/
public String getBaseratecatalogcode(){
  return baseratecatalogcode;
}
/**Fija el valor de baseratecatalogcode
@param pBaseratecatalogcode nuevo Valor de baseratecatalogcode*/
public void setBaseratecatalogcode(String pBaseratecatalogcode){
  baseratecatalogcode=pBaseratecatalogcode;
}

/**Obtiene el valor de recordversion
@return valor de recordversion*/
public Integer getRecordversion(){
  return recordversion;
}
/**Fija el valor de recordversion
@param pRecordversion nuevo Valor de recordversion*/
public void setRecordversion(Integer pRecordversion){
  recordversion=pRecordversion;
}

/**Obtiene el valor de maxterm
@return valor de maxterm*/
public Integer getMaxterm(){
  return maxterm;
}
/**Fija el valor de maxterm
@param pMaxterm nuevo Valor de maxterm*/
public void setMaxterm(Integer pMaxterm){
  maxterm=pMaxterm;
}

/**Obtiene el valor de maxamount
@return valor de maxamount*/
public BigDecimal getMaxamount(){
  return maxamount;
}
/**Fija el valor de maxamount
@param pMaxamount nuevo Valor de maxamount*/
public void setMaxamount(BigDecimal pMaxamount){
  maxamount=pMaxamount;
}

/**Obtiene el valor de margin
@return valor de margin*/
public BigDecimal getMargin(){
  return margin;
}
/**Fija el valor de margin
@param pMargin nuevo Valor de margin*/
public void setMargin(BigDecimal pMargin){
  margin=pMargin;
}

/**Obtiene el valor de operator
@return valor de operator*/
public String getOperator(){
  return operator;
}
/**Fija el valor de operator
@param pOperator nuevo Valor de operator*/
public void setOperator(String pOperator){
  operator=pOperator;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TgeneRatesGroup))return false;
    TgeneRatesGroup that = (TgeneRatesGroup) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementación del metodo hashCode de la la entidad TgeneRatesGroup
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementación toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementación de la creación de un bean en blanco TgeneRatesGroup
*/
public Object createInstance(){
 TgeneRatesGroup instance=new TgeneRatesGroup();	
 instance.setPk(new TgeneRatesGroupKey());
 return instance;
}
/**Clona la entidad TgeneRatesGroup
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TgeneRatesGroup p=(TgeneRatesGroup)this.clone();
  p.setPk((TgeneRatesGroupKey)this.pk.cloneMe());
  return p;
}
}
